/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATMEGA88+ATA6832 
** Pʕ	: SPI_interface.c
** 		: BLDCײ ɎgSPI̪ ٰ
**            "BLDC"Ƃł̎gp̂
**
**  :  		  t: : :
** 1.0   2007N123  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/

/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "SPI_interface.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ ^錾 ___________________________________________________________*/

#if defined(__AVR__)	// AVR GCC߲׎gp
	// SPI荞ݻٰݐ錾
	void SIG_SPI(void) __attribute__ ((signal,naked));
#endif

/*_____ Sϐ ___________________________________________________________*/

SPI_drv_t SPI;			// SPI𗬂ް̐܂B

/*! @brief SPI_MasterInitATA6832𱸾̂ɎgSPI܂B
 *  - SPI(MOSI,SCK,]uI)ɂĎgI/Oo͂Ƃč\ݒ
 *  - 呕u `2MHz(fosc/4)ƂSPI䕔
 *  - ㏸[ްoA~[ō̎SPI\ݒ
 *  - ŏLSBްo
 *  - ]荞݋
 *  - ĳ ײޏ
 */
void SPI_MasterInit(void)
{
	// MOSISCKóȂSĂ͂ɐݒ
	ENABLE_SPI_IO();
	// SPIo͋A呕uAۯxfck/4ɐݒ
	// ㏸[ްݒA~[ް̎A荞݂LSBs
	SPCR = (1<<SPIE) | (1<<SPE) | (1<<MSTR) | (1<<CPHA) | (1<<DORD);
	// ײޏ
	SPI.bytes_to_send_nbr=0;
	// SPIײޏԏ
	SPI.SPI_status = SPI_Ready;
}


/*! @brief SPI_transmit_16(荞݂g)16ޯĂް𑗂邱ƂSPIɎw
 *  ܂B
 *  - SPI̎ɑް擾ē]n߂܂B]n܂Ƃ
 *    ̂SPI_Initiate_txԂ܂B
 *  - Ȃ΁ASPIłȂƁAް͏܂BۂSPIԂ
 *    Ԃ܂B
 * @param data_16
 */
SPI_status_t SPI_transmit_16(unsigned int data_16)
{
	// SPI̎ɑް擾ē]n߂܂B
	if (SPI.SPI_status == SPI_Ready)
	{
		SPI.SPI_status = SPI_Initiate_tx;			// SPIײޏԂXV
		RESET_SPI_SS();								// (SS݂ʂ)]uI
		SPI.Tx_buffer_16 = data_16;					// ɏՕް𕡎
		SPI.bytes_to_send_nbr=2;					// ް ޲ĐL
		SPDR = (unsigned char)(data_16 & 0x00FF);	// ]Jn
	}
	else if (SPI.SPI_status == SPI_Initiate_tx)
	{
		SPI.SPI_status = SPI_Busy;
	}
	1return (SPI.SPI_status);
}


/*! @brief SPI_get_Rx_dataSPIŎMްwꂽɏՕɒu܂B
 * - MްXVꂽ(ASPI])ꍇAް(ҰŒ񋟂ꂽ)
 *   wꂽɏՕɏ܂B
 * - Ȃ΁AwꂽްXVSPIײނ̏ԂԂ܂B
 */
SPI_status_t SPI_get_Rx_data(unsigned int *data_16_ptr)
{
	SPI_status_t report;
	if (SPI.SPI_status == SPI_Completed)
	{
		*data_16_ptr = SPI.Rx_buffer_16;
		SPI.SPI_status = SPI_Ready;
		report = SPI_Completed;
	}
	else
	{
		report = SPI.SPI_status;
	}
	return (report);
}


// SPI interrupt subroutine͂IȂ悤ɱ،ŏĂ܂B
// IAR߲׎gp̏ꍇAۼުĂSPI_STC_ISR.asm̧قǉĂB
// AVR-GCCgp̏ꍇA()SPI_SIG荞ݻٰ݂g܂B
// 3̉IARAVR-GCCׂ̗߲ɑ΂CނSPIٰ݂g߂Ɉȉ
// ̺ނ̒߂OƂłB

/*
//! @brief SPI_STC_ISRSPI]荞ݻٰ݂łB
#if defined(__ICCAVR__)									// IAR߲׎gp
#pragma vector = SPI_STC_vect
__interrupt void SPI_STC_ISR (void)
#else													// AVR GCC߲׎gp
ISR(SPI_STC_vect)
#endif
{

	if (SPI.bytes_to_send_nbr == 2)						// ޲ē]
	{
		SPI.Rx_buffer_16 = (unsigned int)SPDR;			// ]uMްL
		SPDR = ((SPI.Tx_buffer_16 &0xFF00) >> 8);		// ̓]Jn
		SPI.SPI_status = SPI_sending;					// 1޲ē]ςݒʒm
		SPI.bytes_to_send_nbr--;						// oς޲Đ
	}
	else
	{
		SPI.Rx_buffer_16 |= (unsigned int)(SPDR<<8);	// ]uMްL
		SET_SPI_SS();									// ]uI݊J
		SPI.SPI_status =  SPI_Completed;				// ]ʒm
		SPI.bytes_to_send_nbr = 0;
	}
}
*/


// ،ŏꂽSPI]荞ݻٰ
#if defined(__AVR__)		// AVR GCC߲׎gp
void SIG_SPI(void)
{
	asm volatile(															 \
	"PUSH	R24				; gpڼ޽ɉ					\n\t"\
	"IN		R24,0x3F		; SREGڼ޽擾						\n\t"\
	"PUSH	R24				; gpڼ޽ɉ					\n\t"\
																			 \
	"LDS	R24,(SPI)		; SPI.bytes_to_send_nbr擾				\n\t"\
	"CPI	R24,0x02		; ޲ĂȂŁA]				\n\t"\
	"BRNE	transfer_completed											\n\t"\
																			 \
	"send_second_byte:		; ŏ޲ē]							\n\t"\
	"DEC	R24				; SPI.bytes_to_send_nbr				\n\t"\
	"STS	(SPI),R24		;											\n\t"\
	"IN		R24,0x2E		; (SPDR)]uMް擾			\n\t"\
	"STS	(SPI+3),R24		; SPI.Rx_buffer_16̉޲ĂɊi[	\n\t"\
	"LDS	R24,(SPI+2)		; SPI.Tx_buffer_16̏޲Ă擾			\n\t"\
	"OUT	0x2E,R24		; ̓]Ď(SPIMDڼ޽SPDR)	\n\t"\
	"LDI	R24,0x03		; ݒɂ1޲ē]ς݂ʒm			\n\t"\
	"STS	(SPI+5),R24		; SPI.SPI_status = SPI_sending				\n\t"\
	"RJMP	isr_end														\n\t"\
																			 \
	"transfer_completed:												\n\t"\
	"IN		R24,0x2E		; ]uMް擾						\n\t"\
	"STS	(SPI+4),R24		; SPI.Rx_buffer_16̏޲ĂɊi[	\n\t"\
																			 \
	"IN		R24,0x05		; ߰Bo͒l擾							\n\t"\
	"ORI	R24,0x04													\n\t"\
	"OUT	0x05,R24		; SET_SPI_SS(); ߰Bŏ]uIJ		\n\t"\
																			 \
	"LDI	R24,0x04		; ]							\n\t"\
	"STS	(SPI+5),R24		; SPI.SPI_status = SPI_Completed			\n\t"\
	 																		 \
	"isr_end:															\n\t"\
	"POP	R24				; SREGlo					\n\t"\
	"OUT	0x3F,R24		; SREGڼ޽							\n\t"\
	"POP	R24				; gpڼ޽o					\n\t"\
	"RETI																\n\t"\
	);
}
#endif

